local FOLDER_NAME, private = ...
local core = LibStub("AceAddon-3.0"):GetAddon(FOLDER_NAME)
local L = LibStub("AceLocale-3.0"):GetLocale(FOLDER_NAME)
local ACR = LibStub("AceConfigRegistry-3.0")
local LSM = LibStub("LibSharedMedia-3.0")
local version = GetAddOnMetadata(FOLDER_NAME, "X-Version")
local author = GetAddOnMetadata(FOLDER_NAME, "X-Author")
local builddate = GetAddOnMetadata(FOLDER_NAME, "X-Build")
local playerName = UnitName("player")
local pairs, type = pairs, type
local getOpt, setOpt
local outlines = {
	[""] = NONE,
	["OUTLINE"] = L["Outline"],
	["THICKOUTLINE"] = L["Thick Outline"],
	["MONOCHROMEOUTLINE"] = L["Monochrome Outline"],
}

do
	function getOpt(info)
		local key = info[#info]
		return core.db.profile[key]
	end

	function setOpt(info, value)
		local key = info[#info]
		core.db.profile[key] = value
		core:applySettings()
	end
end

local BOMDropDownMenu = CreateFrame("Frame", "BOMDropDownMenu")
BOMDropDownMenu.displayMode = "MENU"
BOMDropDownMenu.info = {}
BOMDropDownMenu.uncheck = function(dropdownbutton)
	_G[dropdownbutton:GetName() .. "Check"]:Hide()
end

local info = {}
BOMDropDownMenu.initialize = function(self, level)
	if not level then return end
	local info = self.info
	wipe(info)
	if level == 1 then
		info.keepShownOnClick = 1
		info.isTitle = 1
		info.text = "Broker MiningMats"
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
		info.isTitle = nil
		info.text = ""
		info.disabled = 1
		UIDropDownMenu_AddButton(info, level)
		info.isTitle = 1
		info.text = L["Tracking Options"]
		UIDropDownMenu_AddButton(info, level)
		info.isTitle = nil
		info.disabled = nil
		info.hasArrow = 1
		info.text = ("|cffffff99" .. L["Vanilla"] .. "|r")
		info.value = "submenu1"
		info.func = self.uncheck
		UIDropDownMenu_AddButton(info, level)
		info.text = ("|cff00ff00" .. L["The Burning Crusade"] .. "|r")
		info.value = "submenu2"
		info.func = self.uncheck
		UIDropDownMenu_AddButton(info, level)
		info.text = ("|cff0066ff" .. L["Wrath of the Lich King"] .. "|r")
		info.value = "submenu3"
		info.func = self.uncheck
		UIDropDownMenu_AddButton(info, level)
		info.text = ("|cffff6600" .. L["Cataclysm"] .. "|r")
		info.value = "submenu4"
		info.func = self.uncheck
		UIDropDownMenu_AddButton(info, level)
		info.text = ("|cff19ac87" .. L["Mists of Pandaria"] .. "|r")
		info.value = "submenu5"
		info.func = self.uncheck
		UIDropDownMenu_AddButton(info, level)
		info.text = ("|cfffd482f" .. L["Warlords of Draenor"] .. "|r")
		info.value = "submenu6"
		info.func = self.uncheck
		UIDropDownMenu_AddButton(info, level)
		info.text = ("|cff299f06" .. L["Legion"] .. "|r")
		info.value = "submenu7"
		info.func = self.uncheck
		UIDropDownMenu_AddButton(info, level)
		info.hasArrow = nil
		if core.db.profile.showallopts then
			info.notCheckable = nil
			info.text = L["Show icons on the tracker."]
			info.func = function() core.db.profile.showIcons = not core.db.profile.showIcons CloseDropDownMenus() core:applySettings() ToggleDropDownMenu(1, nil, BOMDropDownMenu, private.fname, 0, 0) end
			info.checked = function() return core.db.profile.showIcons end
			UIDropDownMenu_AddButton(info, level)
			if core.db.profile.showIcons then
				info.text = L["Show icons only on the tracker."]
				info.func = function() core.db.profile.iconsOnly = not core.db.profile.iconsOnly CloseDropDownMenus() core:applySettings() ToggleDropDownMenu(1, nil, BOMDropDownMenu, private.fname, 0, 0) end
				info.checked = function() return core.db.profile.iconsOnly end
				UIDropDownMenu_AddButton(info, level)
			end
			if not core.db.profile.iconsOnly or not core.db.profile.showIcons then
				info.text = L["Show short text on the tracker."]
				info.func = function() core.db.profile.showShort = not core.db.profile.showShort core:applySettings() end
				info.checked = function() return core.db.profile.showShort end
				UIDropDownMenu_AddButton(info, level)
			end
		end
			info.notCheckable = 1
			info.text = ""
			info.disabled = 1
			UIDropDownMenu_AddButton(info, level)
			info.isTitle = 1
			info.text = L["Tooltip Options"]
			UIDropDownMenu_AddButton(info, level)
			info.isTitle = nil
			info.notCheckable = nil
			info.disabled = nil
			info.text = ("|cffffff99" .. L["Vanilla"] .. "|r")
			info.func = function() core.db.profile.modules.omv = not core.db.profile.modules.omv core:applySettings() end
			info.checked = function() return core.db.profile.modules.omv end
			UIDropDownMenu_AddButton(info, level)
			info.text = ("|cff00ff00" .. L["The Burning Crusade"] .. "|r")
			info.func = function() core.db.profile.modules.ombc = not core.db.profile.modules.ombc core:applySettings() end
			info.checked = function() return core.db.profile.modules.ombc end
			UIDropDownMenu_AddButton(info, level)
			info.text = ("|cff0066ff" .. L["Wrath of the Lich King"] .. "|r")
			info.func = function() core.db.profile.modules.omlk = not core.db.profile.modules.omlk core:applySettings() end
			info.checked = function() return core.db.profile.modules.omlk end
			UIDropDownMenu_AddButton(info, level)
			info.text = ("|cffff6600" .. L["Cataclysm"] .. "|r")
			info.func = function() core.db.profile.modules.omcata = not core.db.profile.modules.omcata core:applySettings() end
			info.checked = function() return core.db.profile.modules.omcata end
			UIDropDownMenu_AddButton(info, level)
			info.text = ("|cff19ac87" .. L["Mists of Pandaria"] .. "|r")
			info.func = function() core.db.profile.modules.ommop = not core.db.profile.modules.ommop core:applySettings() end
			info.checked = function() return core.db.profile.modules.ommop end
			UIDropDownMenu_AddButton(info, level)
			info.text = ("|cfffd482f" .. L["Warlords of Draenor"] .. "|r")
			info.func = function() core.db.profile.modules.omwod = not core.db.profile.modules.omwod core:applySettings() end
			info.checked = function() return core.db.profile.modules.omwod end
			UIDropDownMenu_AddButton(info, level)
			info.text = ("|cff299f06" .. L["Legion"] .. "|r")
			info.func = function() core.db.profile.modules.omleg = not core.db.profile.modules.omleg core:applySettings() end
			info.checked = function() return core.db.profile.modules.omleg end
			UIDropDownMenu_AddButton(info, level)
		if core.db.profile.showallopts then
			info.text = L["Show zero counts in the tooltip."]
			info.func = function() core.db.profile.showZero = not core.db.profile.showZero core:applySettings() end
			info.checked = function() return core.db.profile.showZero end
			UIDropDownMenu_AddButton(info, level)
			info.text = L["Show bank counts in the tooltip."]
			info.func = function() core.db.profile.showBank = not core.db.profile.showBank core:applySettings() end
			info.checked = function() return core.db.profile.showBank end
			UIDropDownMenu_AddButton(info, level)
			info.text = L["Show alt counts in the tooltip."]
			info.func = function() core.db.profile.showAlts = not core.db.profile.showAlts core:applySettings() end
			info.checked = function() return core.db.profile.showAlts end
			UIDropDownMenu_AddButton(info, level)
			info.text = L["Show guild counts in the tooltip."]
			info.func = function() core.db.profile.showGuild = not core.db.profile.showGuild core:applySettings() end
			info.checked = function() return core.db.profile.showGuild end
			UIDropDownMenu_AddButton(info, level)
			info.text = L["Show totals in the tooltip."]
			info.func = function() core.db.profile.showTotal = not core.db.profile.showTotal core:applySettings() end
			info.checked = function() return core.db.profile.showTotal end
			UIDropDownMenu_AddButton(info, level)
			info.text = L["Show icons in the tooltip."]
			info.func = function() core.db.profile.tooltipIcons = not core.db.profile.tooltipIcons CloseDropDownMenus() core:applySettings() ToggleDropDownMenu(1, nil, BOMDropDownMenu, private.fname, 0, 0) end
			info.checked = function() return core.db.profile.tooltipIcons end
			UIDropDownMenu_AddButton(info, level)
			if core.db.profile.tooltipIcons then
				info.text = L["Show icons only in the tooltip."]
				info.func = function() core.db.profile.tooltipIconsOnly = not core.db.profile.tooltipIconsOnly CloseDropDownMenus() core:applySettings() ToggleDropDownMenu(1, nil, BOMDropDownMenu, private.fname, 0, 0) end
				info.checked = function() return core.db.profile.tooltipIconsOnly end
				UIDropDownMenu_AddButton(info, level)
			end
			if not core.db.profile.tooltipIconsOnly or not core.db.profile.tooltipIcons then
				info.text = L["Show short text in the tooltip."]
				info.func = function() core.db.profile.tooltipShowShort = not core.db.profile.tooltipShowShort core:applySettings() end
				info.checked = function() return core.db.profile.tooltipShowShort end
				UIDropDownMenu_AddButton(info, level)
			end
			info.text = L["Color lines in the tooltip."]
			info.func = function() core.db.profile.lineColor = not core.db.profile.lineColor core:applySettings() end
			info.checked = function() return core.db.profile.lineColor end
			UIDropDownMenu_AddButton(info, level)
			info.text = L["Color text in the tooltip."]
			info.func = function() core.db.profile.textColor = not core.db.profile.textColor core:applySettings() end
			info.checked = function() return core.db.profile.textColor end
			UIDropDownMenu_AddButton(info, level)
		end
		info.notCheckable = 1
		info.text = ""
		info.disabled = 1
		UIDropDownMenu_AddButton(info, level)
		info.disabled = nil
		info.text = L["Close"]
		info.func = function() CloseDropDownMenus() end
		UIDropDownMenu_AddButton(info, level)
	elseif level == 2 then
		if UIDROPDOWNMENU_MENU_VALUE == "submenu1" then
			info.keepShownOnClick = 1
			for k, itemid in pairs(private.vanores.id) do
				local color = private.vanores.color[k]
				if not core.db.profile.textColor then color = "FFFFFF" end
				local name = private.vanores.strings[k]
				local itype = private.vanores.itype[k]
				local item
				if itype == 1 then
					itype = L["Ore"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				elseif itype == 2 then
					itype = L["Bar"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				elseif itype == 3 then
					itype = L["Nugget"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				else
					item = "|cff" .. color .. name .. "|r"
				end
				local fixeditem = strsub(itemid, 1, -1)
				info.text = item
				info.func = function() core.db.profile.tracking[fixeditem] = not core.db.profile.tracking[fixeditem] core:applySettings() end
				info.checked = function() return core.db.profile.tracking[fixeditem] end
				UIDropDownMenu_AddButton(info, level)
			end
		end
		if UIDROPDOWNMENU_MENU_VALUE == "submenu2" then
			info.keepShownOnClick = 1
			for k, itemid in pairs(private.bcores.id) do
				local color = private.bcores.color[k]
				if not core.db.profile.textColor then color = "FFFFFF" end
				local name = private.bcores.strings[k]
				local itype = private.bcores.itype[k]
				local item
				if itype == 1 then
					itype = L["Ore"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				elseif itype == 2 then
					itype = L["Bar"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				elseif itype == 3 then
					itype = L["Nugget"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				else
					item = "|cff" .. color .. name .. "|r"
				end
				local fixeditem = strsub(itemid, 1, -1)
				info.text = item
				info.func = function() core.db.profile.tracking[fixeditem] = not core.db.profile.tracking[fixeditem] core:applySettings() end
				info.checked = function() return core.db.profile.tracking[fixeditem] end
				UIDropDownMenu_AddButton(info, level)
			end
		end
		if UIDROPDOWNMENU_MENU_VALUE == "submenu3" then
			info.keepShownOnClick = 1
			for k, itemid in pairs(private.lkores.id) do
				local color = private.lkores.color[k]
				if not core.db.profile.textColor then color = "FFFFFF" end
				local name = private.lkores.strings[k]
				local itype = private.lkores.itype[k]
				local item
				if itype == 1 then
					itype = L["Ore"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				elseif itype == 2 then
					itype = L["Bar"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				elseif itype == 3 then
					itype = L["Nugget"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				else
					item = "|cff" .. color .. name .. "|r"
				end
				local fixeditem = strsub(itemid, 1, -1)
				info.text = item
				info.func = function() core.db.profile.tracking[fixeditem] = not core.db.profile.tracking[fixeditem] core:applySettings() end
				info.checked = function() return core.db.profile.tracking[fixeditem] end
				UIDropDownMenu_AddButton(info, level)
			end
		end
		if UIDROPDOWNMENU_MENU_VALUE == "submenu4" then
			info.keepShownOnClick = 1
			for k, itemid in pairs(private.cataores.id) do
				local color = private.cataores.color[k]
				if not core.db.profile.textColor then color = "FFFFFF" end
				local name = private.cataores.strings[k]
				local itype = private.cataores.itype[k]
				local item
				if itype == 1 then
					itype = L["Ore"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				elseif itype == 2 then
					itype = L["Bar"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				elseif itype == 3 then
					itype = L["Nugget"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				else
					item = "|cff" .. color .. name .. "|r"
				end
				local fixeditem = strsub(itemid, 1, -1)
				info.text = item
				info.func = function() core.db.profile.tracking[fixeditem] = not core.db.profile.tracking[fixeditem] core:applySettings() end
				info.checked = function() return core.db.profile.tracking[fixeditem] end
				UIDropDownMenu_AddButton(info, level)
			end
		end
		if UIDROPDOWNMENU_MENU_VALUE == "submenu5" then
			info.keepShownOnClick = 1
			for k, itemid in pairs(private.mopores.id) do
				local color = private.mopores.color[k]
				if not core.db.profile.textColor then color = "FFFFFF" end
				local name = private.mopores.strings[k]
				local itype = private.mopores.itype[k]
				local item
				if itype == 1 then
					itype = L["Ore"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				elseif itype == 2 then
					itype = L["Bar"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				elseif itype == 3 then
					itype = L["Nugget"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				else
					item = "|cff" .. color .. name .. "|r"
				end
				local fixeditem = strsub(itemid, 1, -1)
				info.text = item
				info.func = function() core.db.profile.tracking[fixeditem] = not core.db.profile.tracking[fixeditem] core:applySettings() end
				info.checked = function() return core.db.profile.tracking[fixeditem] end
				UIDropDownMenu_AddButton(info, level)
			end
		end
		if UIDROPDOWNMENU_MENU_VALUE == "submenu6" then
			info.keepShownOnClick = 1
			for k, itemid in pairs(private.wodores.id) do
				local color = private.wodores.color[k]
				if not core.db.profile.textColor then color = "FFFFFF" end
				local name = private.wodores.strings[k]
				local itype = private.wodores.itype[k]
				local item
				if itype == 1 then
					itype = L["Ore"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				elseif itype == 2 then
					itype = L["Bar"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				elseif itype == 3 then
					itype = L["Nugget"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				else
					item = "|cff" .. color .. name .. "|r"
				end
				local fixeditem = strsub(itemid, 1, -1)
				info.text = item
				info.func = function() core.db.profile.tracking[fixeditem] = not core.db.profile.tracking[fixeditem] core:applySettings() end
				info.checked = function() return core.db.profile.tracking[fixeditem] end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	  if UIDROPDOWNMENU_MENU_VALUE == "submenu7" then
			info.keepShownOnClick = 1
			for k, itemid in pairs(private.legores.id) do
				local color = private.legores.color[k]
				if not core.db.profile.textColor then color = "FFFFFF" end
				local name = private.legores.strings[k]
				local itype = private.legores.itype[k]
				local item
				if itype == 1 then
					itype = L["Ore"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				elseif itype == 2 then
					itype = L["Bar"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				elseif itype == 3 then
					itype = L["Nugget"]
					item = "|cff" .. color .. name .. " " .. itype .. "|r"
				else
					item = "|cff" .. color .. name .. "|r"
				end
				local fixeditem = strsub(itemid, 1, -1)
				info.text = item
				info.func = function() core.db.profile.tracking[fixeditem] = not core.db.profile.tracking[fixeditem] core:applySettings() end
				info.checked = function() return core.db.profile.tracking[fixeditem] end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end
end

local options, moduleOptions = nil, {}
local function getOptions()
	if not options then
		options = {
			type = "group",
			name = "Broker MiningMats",
			args = {
				display = {
					order = 0,
					type = "group",
					inline = true,
					name = L["Options"],
					args = {
						author = {
							order = 5,
							type = "description",
							name = L["Author: "] .. author .. "    " .. L["Version: "] .. version .. "    " .. L["Build Date: "] .. builddate
						},
						options = {
							type = "group",
							name = L["Right-Click Options"],
							inline = true,
							order = 10,
							args = {
								showallopts = {
									type = "toggle",
									order = 15,
									width = "full",
									name = L["Show Display, Tracking, and Tooltip options on Right-Click menu."],
									get = function() return core.db.profile.showallopts end,
									set = function(info, value)
										core.db.profile.showallopts = value
										CloseDropDownMenus()
									end,
								},
							},
						},
						counts = {
							type = "group",
							width = "full",
							name = L["Display Options"],
							childGroups = "tab",
							order = 20,
							args = {
								showZero = {
									type = "toggle",
									order = 25,
									width = "full",
									name = L["Show zero counts in the tooltip."],
									get = getOpt,
									set = setOpt,
								},
								showBank = {
									type = "toggle",
									order = 30,
									width = "full",
									name = L["Show bank counts in the tooltip."],
									get = getOpt,
									set = setOpt,
								},
								showGuild = {
									type = "toggle",
									order = 35,
									width = "full",
									name = L["Show guild counts in the tooltip."],
									get = getOpt,
									set = setOpt,
								},
								showAlts = {
									type = "toggle",
									order = 40,
									width = "full",
									name = L["Show alt counts in the tooltip."],
									get = getOpt,
									set = setOpt,
								},
								showTotal = {
									type = "toggle",
									order = 45,
									width = "full",
									name = L["Show total count from all characters and sources in the tooltip."],
									get = getOpt,
									set = setOpt,
								},
							},
						},
						tracking = {
							type = "group",
							name = L["Tracking Options"],
							childGroups = "tab",
							order = 50,
							args = {
								showIcons = {
									type = "toggle",
									order = 55,
									width = "full",
									name = L["Show icons on the tracker."],
									get = getOpt,
									set = setOpt,
								},
								iconsOnly = {
									type = "toggle",
									order = 60,
									width = "full",
									name = L["Show icons only on the tracker."],
									get = getOpt,
									set = setOpt,
									hidden = function() return not core.db.profile.showIcons end
								},
								showShort = {
									type = "toggle",
									order = 65,
									width = "full",
									name = L["Show short text on the tracker."],
									get = getOpt,
									set = setOpt,
									hidden = function() if core.db.profile.showIcons and core.db.profile.iconsOnly then return true end end
								},
							},
						},
						tooltip = {
							type = "group",
							name = L["Tooltip Options"],
							childGroups = "tab",
							order = 70,
							args = {
								scale = {
									order = 75,
									type = "range",
									name = L["Scale"],
									min = .5,
									max = 1.5,
									step = .05,
									get = getOpt,
									set = setOpt,
								},
								scroll = {
									order = 80,
									type = "range",
									name = L["Height"],
									min = 100,
									max = 900,
									step = 25,
									get = getOpt,
									set = setOpt,
								},
								tooltipIcons = {
									type = "toggle",
									order = 85,
									width = "full",
									name = L["Show icons in the tooltip."],
									get = getOpt,
									set = setOpt,
								},
								tooltipIconsOnly = {
									type = "toggle",
									order = 90,
									width = "full",
									name = L["Show icons only in the tooltip."],
									get = getOpt,
									set = setOpt,
									hidden = function() return not core.db.profile.tooltipIcons end
								},
								tooltipShowShort = {
									type = "toggle",
									order = 95,
									width = "full",
									name = L["Show short text in the tooltip."],
									get = getOpt,
									set = setOpt,
									hidden = function() if core.db.profile.tooltipIcons and core.db.profile.tooltipIconsOnly then return true end end
								},
								lineColor = {
									type = "toggle",
									order = 100,
									width = "full",
									name = L["Color lines in the tooltip."],
									get = getOpt,
									set = setOpt,
								},
								textColor = {
									type = "toggle",
									order = 105,
									width = "full",
									name = L["Color text in the tooltip."],
									get = getOpt,
									set = setOpt,
								},
							},
						},
						fonts = {
							type = "group",
							name = L["Font Options"],
							childGroups = "tab",
							order = 110,
							args = {
								name = {
									type = "group",
									inline = true,
									name = L["Name Font"],
									order = 115,
									args = {
										namefont = {
											name = L["Font"],
											desc = L["The font used for this element."],
											type = "select", dialogControl = 'LSM30_Font',
											order = 120,
											values = AceGUIWidgetLSMlists.font,
											get = function() return core.db.profile.namefont end,
											set = function(info, value)
												core.db.profile.namefont = value
												core:updateFonts()
											end,
										},
										namefontsize = {
											name = L["Font Size"],
											desc = L["The size that this font will use."],
											type = "range",
											order = 125,
											min = 8,
											max = 20,
											step = 1,
											get = function() return core.db.profile.namefontsize end,
											set = function(info, value)
												core.db.profile.namefontsize = value
												core:updateFonts()
											end,
										},
										namefontol = {
											name = L["Font Outline"],
											desc = L["The outline that this font will use."],
											type = "select",
											order = 130,
											values = outlines,
											get = function() return core.db.profile.namefontol end,
											set = function(info, value)
												core.db.profile.namefontol = value
												core:updateFonts()
											end,
										},
									},
								},
								header = {
									type = "group",
									name = L["Header Font"],
									inline = true,
									order = 135,
									args = {
										headerfont = {
											name = L["Font"],
											desc = L["The font used for this element."],
											type = "select", dialogControl = 'LSM30_Font',
											order = 140,
											values = AceGUIWidgetLSMlists.font,
											get = function() return core.db.profile.headerfont end,
											set = function(info, value)
												core.db.profile.headerfont = value
												core:updateFonts()
											end,
										},
										headerfontsize = {
											name = L["Font Size"],
											desc = L["The size that this font will use."],
											type = "range",
											order = 145,
											min = 8,
											max = 20,
											step = 1,
											get = function() return core.db.profile.headerfontsize end,
											set = function(info, value)
												core.db.profile.headerfontsize = value
												core:updateFonts()
											end,
										},
										headerfontol = {
											name = L["Font Outline"],
											desc = L["The outline that this font will use."],
											type = "select",
											order = 150,
											values = outlines,
											get = function() return core.db.profile.headerfontol end,
											set = function(info, value)
												core.db.profile.headerfontol = value
												core:updateFonts()
											end,
										},
									},
								},
								text = {
									type = "group",
									name = L["Text Font"],
									inline = true,
									order = 155,
									args = {
										textfont = {
											name = L["Font"],
											desc = L["The font used for this element."],
											type = "select", dialogControl = 'LSM30_Font',
											order = 160,
											values = AceGUIWidgetLSMlists.font,
											get = function() return core.db.profile.textfont end,
											set = function(info, value)
												core.db.profile.textfont = value
												core:updateFonts()
											end,
										},
										textfontsize = {
											name = L["Font Size"],
											desc = L["The size that this font will use."],
											type = "range",
											order = 165,
											min = 8,
											max = 20,
											step = 1,
											get = function() return core.db.profile.textfontsize end,
											set = function(info, value)
												core.db.profile.textfontsize = value
												core:updateFonts()
											end,
										},
										textfontol = {
											name = L["Font Outline"],
											desc = L["The outline that this font will use."],
											type = "select",
											order = 170,
											values = outlines,
											get = function() return core.db.profile.textfontol end,
											set = function(info, value)
												core.db.profile.textfontol = value
												core:updateFonts()
											end,
										},
									},
								},
								number = {
									type = "group",
									name = L["Number Font"],
									inline = true,
									order = 175,
									args = {
										numberfont = {
											name = L["Font"],
											desc = L["The font used for this element."],
											type = "select", dialogControl = 'LSM30_Font',
											order = 180,
											values = AceGUIWidgetLSMlists.font,
											get = function() return core.db.profile.numberfont end,
											set = function(info, value)
												core.db.profile.numberfont = value
												core:updateFonts()
											end,
										},
										numberfontsize = {
											name = L["Font Size"],
											desc = L["The size that this font will use."],
											type = "range",
											order = 185,
											min = 8,
											max = 20,
											step = 1,
											get = function() return core.db.profile.numberfontsize end,
											set = function(info, value)
												core.db.profile.numberfontsize = value
												core:updateFonts()
											end,
										},
										numberfontol = {
											name = L["Font Outline"],
											desc = L["The outline that this font will use."],
											type = "select",
											order = 190,
											values = outlines,
											get = function() return core.db.profile.numberfontol end,
											set = function(info, value)
												core.db.profile.numberfontol = value
												core:updateFonts()
											end,
										},
									},
								},
							},
						},
						purge = {
							type = "group",
							name = L["Delete Character"],
							childGroups = "tab",
							order = 195,
							args = {
								deleteChar = {
									type = "select",
									order = 200,
									name = L["Delete Character"],
									desc = L["This action will force a UI reload."],
									values = private.charsList,
									set = function(v, alt)
										core:purgeData(alt)
									end
								},
							},
						},
					},
				},
			},
		}
		for k, v in pairs(moduleOptions) do
			options.args[k] = (type(v) == "function") and v() or v
		end
	end
	return options
end

function core:SetupOptions()
	self.optFrames = {}
	ACR:RegisterOptionsTable(FOLDER_NAME, getOptions)
	self.optFrames.core = LibStub("AceConfigDialog-3.0"):AddToBlizOptions(FOLDER_NAME, "Broker MiningMats", nil, "display")
	self.optFrames.core.default = function() core:SetDefaultOptions() end
	self:RegisterModuleOptions("Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(core.db), "Profiles")
end

function core:SetDefaultOptions()
	core.db:ResetProfile()
	ACR:NotifyChange(FOLDER_NAME)
end

function core:RegisterModuleOptions(name, optTable, displayName)
	moduleOptions[name] = optTable
	self.optFrames[name] = LibStub("AceConfigDialog-3.0"):AddToBlizOptions(FOLDER_NAME, displayName or name, "Broker MiningMats", name)
end

function core:purgeData(alt)
	core.db.realm.chars[alt] = nil
	ReloadUI()
end
